	{ I. Vatton 	 February 1999  }

{ Variables used in ifdefs: PAGE, US_PAPER }
PRESENTATION TextFile;

VIEWS
   Formatted_view;

#ifdef US_PAPER
#define PAGE
#endif { US_PAPER }

#ifdef PAGE
PRINT
   Formatted_view;
#endif  { PAGE }

COUNTERS
#ifdef PAGE
   PageCounter: Rank of Page(Formatted_view);
#else
   LineCounter: Rank of Line\240;
#endif

DEFAULT

   BEGIN
   HorizRef: Enclosed . HRef;
   VertRef: * . Left;
   Width: Enclosed . Width;
   Height: Enclosed . Height;
   VertPos: Top = Previous . Bottom;
   HorizPos: Left = Enclosing . Left;
   Justify: Enclosing =;
   LineSpacing: Enclosing =;
   Visibility: Enclosing =;
   Font: Enclosing =;
   Style: Enclosing =;
   Weight: Enclosing =;
   Size: Enclosing =;
   Adjust: Left;
   Indent: Enclosing =;
   Depth: 0;
   UnderLine: Enclosing =;
   Thickness: Enclosing =;
   LineStyle: Enclosing =;
   LineWeight: Enclosing =;
   Background: Enclosing =;
   Foreground: Enclosing =;
   END;

BOXES

{ ---- Pages ---- }
#ifdef PAGE
  URLhead:
	BEGIN
	Background: White;
	Foreground: Black;
	Fillpattern: nopattern;
	Underline: NoUnderline;
	Copy (Document_URL);
	Justify: No;
	HorizPos: Left = Previous PAGE_BREAK . Left;
	VertPos: Top = Previous PAGE_BREAK . Bottom + 0.7 cm;
	Width: Enclosed . Width;
	Height:   1.2 cm;
	Size: 8 pt;
	Font: times;
	Style: Roman;	
	Weight: Normal;
	END;

  Spacehead:
	BEGIN
	Background: White;
	Foreground: Black;
	Fillpattern: nopattern;
	Underline: NoUnderline;
	Content: Text ' ';
	Justify: No;
	HorizPos: Left = Previous PAGE_BREAK . Left;
	VertPos: Top = Previous PAGE_BREAK . Bottom + 0.7 cm;
	Height:   1.2 cm;
	Size: 8 pt;
	Font: times;
	Style: Roman;
	Weight: Normal;
	END;

  PageNum:
	BEGIN
	Background: White;
	Foreground: Black;
	Fillpattern: nopattern;
	Underline: NoUnderline;
	Content: (Value (PageCounter, Arabic));
	VertPos: Top = Next PAGE_BREAK . Top - 0.5 cm;
	HorizPos: VMiddle = Next PAGE_BREAK . VMiddle;
	Height:   1.6 cm;
	Width: Enclosed .Width;
	Size: 11 pt;
	Font: times;
	Style: Roman;
	Weight: Normal;
	END;

  BottomSpace:
	BEGIN
	Background: White;
	Foreground: Black;
	FillPattern: backgroundcolor;
	Height: 1.4 cm;
	Width: 1 pt;
	Underline: NoUnderline;
	VertPos: Bottom = Next PAGE_BREAK . Top;
	HorizPos: Left = Next PAGE_BREAK . Left;
	Content: (Graphics ' ');
	END;

  ThePage:
	BEGIN
	Background: White;
	Foreground: Black;
	FillPattern: backgroundcolor;
	ShowBox;
#ifdef US_PAPER
	Width: 16.2 cm;
	Height: 23.8 cm;
	VertPos: Top = Enclosing . Top + 1.7 cm;
	HorizPos: Left = Enclosing . Left + 2.7 cm;
#else
	Width: 15.6 cm;
	Height: 25.9 cm;
	VertPos: Top = Enclosing . Top + 1.7 cm;
	HorizPos: Left = Enclosing . Left + 2.7 cm;
#endif { US_PAPER }
	CreateAfter (Spacehead);
	if PrintURL
	   CreateAfter (URLhead);
	if NOT One(PageCounter) CreateBefore (PageNum);
	IF Not One(PageCounter) CreateBefore (BottomSpace);
	Underline: NoUnderline;
	END;
#else { PAGE }

  RightSpace:
	BEGIN
	Fillpattern: nopattern;
	Underline: NoUnderline;
	Content: Text '   ';
	Justify: No;
	HorizPos: Left = BODY . Right;
	VertPos: Top = Enclosing . Top;
	Width: Enclosed . Width;
	Height: 1;
	Size: 12 pt;
	Font: times;
	Style: Roman;
	Weight: Normal;
	END;

  IndexBox: BEGIN
        Content: Picture 'index.gif';
        HorizPos: Left = Root . Left;
        VertPos: Top = Enclosing . Top;
        VertOverflow : Yes;
        HorizOverflow : Yes;
        Inline: No;
        Visibility: Creator =;
        END;

  LineNum:
	BEGIN
	Foreground: Blue;
	Content: (Value (LineCounter, Arabic));
	END;

#endif { PAGE }

RULES

  Document_URL:	BEGIN
	Visibility: 1;
	END;

  TextFile: BEGIN
	Font: Courier;
	Style: Roman;
	Weight: Normal;
	Adjust: Left;
#ifdef PAGE
	Size: 10 pt;
	HorizPos: VMiddle = Enclosing.VMiddle;
	Page(ThePage);
	Width: Enclosing . Width;
#else
	Size: 12 pt;
	HorizPos: Left = Enclosing . Left;
	Width: Enclosed . Width;
#endif
	Vertpos: Top = Previous . Bottom + 0.4;
	Indent: 0;
	Justify: No;
	LineSpacing: 1;
	END;

  BODY: BEGIN
	HorizPos: Left = Enclosing . Left + 1;
#ifdef PAGE
	Width: Enclosing . Width - 2;
#else
	CreateWith (RightSpace);
	Width: Enclosed . Width;
#endif
	END;

  Line\240: BEGIN
	Line;
	LineBreak: Yes;
#ifdef PAGE
	Width: Enclosing . Width;
#else
	Width: Enclosed . Width;
#endif
	END;

  TEXT_UNIT :
	 Width: Enclosed . Width;

ATTRIBUTES

#ifndef PAGE
  Source (Line\240):
	BEGIN
	CreateBefore (LineNum);
	VertPos: HRef = Previous LineNum . HRef;
	HorizPos: Left = Enclosing . Left + 3;
	END;

  Highlight:
	CreateFirst (IndexBox);
#endif

END
