/*
 *
 *  (c) COPYRIGHT MIT and INRIA, 1996.
 *  Please first read the full copyright statement in file COPYRIGHT.
 *
 */

/*
 * Warning:
 * This module is part of the Thot library, which was originally
 * developed in French. That's why some comments are still in
 * French, but their translation is in progress and the full module
 * will be available in English in the next release.
 * 
 */
 
#ifndef LIB_MSG_H
#define LIB_MSG_H

/* ---  --- --- --- MESSAGES FOR THE LIBRARY --- --- --- ---  */

/*=====   Simple messages                                     */

#define TMSG_LIB_X11_ERR			       0
#define TMSG_MISSING_VIEW			       1
#define TMSG_ERR_LOADING_DICO			       2
#define TMSG_LIB_MISSING_FILE			       3
#define TMSG_WRITING_IMP			       4
#define TMSG_SCHEMA_NOT_FIND			       5
#define TMSG_LIB_CONFIRM			       6
#define TMSG_MISSING_ALPHABET			       7
#define TMSG_OPEN_DOC_IMP			       8
#define TMSG_ERR_PIV			               9
#define TMSG_OLD_VIEW_NOT_REPLACED	              10
#define TMSG_OLD_SCH_TO_RECOMP		              11
#define TMSG_BAD_FRAME_NB		              12
#define TMSG_MISSING_FONT			      13
#define TMSG_COLUMNS_PAGINATE_AGAIN	              14
#define TMSG_NO_MEMORY			              15
#define TMSG_UNABLE_TO_CONNECT_TO_X		      16
#define TMSG_VIEW_MODIFIED_BEFORE_CREATION	      17
#define TMSG_SEL_BEFORE			              18
#define TMSG_NO_PLACE_FOR_FONT		              19
#define TMSG_INCORRECT_DOC_STRUCTURE	              20
#define TMSG_LOCKED_DOC			              21
#define TMSG_LIB_RULES_TABLE_FULL		      22
#define TMSG_STR_SCH_CHANGED		              23
#define TMSG_INCORRECT_STR_FILE			      24
#define TMSG_INCORRECT_PRS_FILE			      25
#define TMSG_MISSING_DIR		              26
#define TMSG_PRINT_IMP			              27
#define TMSG_CHANGE_PRES_IMP			      28
#define TMSG_SAVE_IN_PS_IMP		              29
#define TMSG_IMPORT_FILE_IMP			      30
#define TMSG_EMPTY_VIEW			              31
#define TMSG_RO_EL_FORBIDDEN		              32
#define TMSG_DON_T_COPY_PAIRED_EL		      33
#define TMSG_NEW_DICO				      34
#define TMSG_PICT_TYPE				      35
#define TMSG_PICT_PRES				      36
#define TMSG_PICT_FILE				      37
#define TMSG_DOC_PRINTED                              38
#define TMSG_FIRST_PAGE				      39
#define TMSG_LAST_PAGE				      40
#define TMSG_NB_COPIES				      41
#define TMSG_REDUCTION				      42
#define TMSG_1_PAGE_SHEET			      43
#define TMSG_2_PAGE_SHEET			      44
#define TMSG_4_PAGE_SHEET			      45
#define TMSG_NB_PAGE_SHEET			      46
#define TMSG_PAGINATE				      47
#define TMSG_VIEWS_TO_PRINT			      48
#define TMSG_CHANGE_PSCH			      49
#define TMSG_A_COPY			              50
#define TMSG_LIB_NO_LOAD			      51
#define TMSG_MISSING_DICOPAR			      52
#define TMSG_SELF_REF_IMP	                      53
#define TMSG_LIB_ATTR_REQUIRED_NOT_DELETED	      54
#define TMSG_NATURE_FORBIDDEN		              55
#define TMSG_LIB_MANDATORY_COMPONENT		      56
#define TMSG_SEL_ONE_COMPONENT		              57
#define TMSG_PASTING_EL_IMP	                      58
#define TMSG_MODIFYING_BOX_IMP	                      59
#define TMSG_LIB_STRING				      60
#define TMSG_NO_VIEW_SEL_FOR_PRINTING	              61
#define TMSG_ENTER_PRS_SCH			      62
#define TMSG_READING_DOC			      63
#define TMSG_SEL_EL			              64
#define TMSG_NO_KBD			              65
#define TMSG_X_BUF_UNMODIFIED			      66
#define TMSG_COPYING_DIFFERENT_COMPONENTS_IMP	      67
#define TMSG_RO_DOC_FORBIDDEN		              68
#define TMSG_SELF_DOC_INCLUSION_IMP	              69
#define TMSG_MODIFYING_BOX			      70
#define TMSG_MOVING_BOX			              71
#define TMSG_LIB_DOC_WRITTEN		              72
#define TMSG_WRITING				      73
#define TMSG_EMPTY_REF				      74
#define TMSG_COPYING_PAGE_BRK_IMP		      75
#define TMSG_SEL_EL_MANDATORY		              76
#define TMSG_MODIFYING_DIR_LIST		              77
#define TMSG_PRINTING		                      78
#define TMSG_EXPORTING				      79
#define TMSG_DICO				      80
#define TMSG_SAVE_IN_PS		                      81
#define TMSG_IMPORTING_FILE			      82
#define TMSG_CHOOSE_DOC_FORM_FOR_LOADING	      83
#define TMSG_TWO_POINTS_IN_POLYLINE_NEEDED	      84
#define TMSG_VAL_FOR_ATTR_REQUESTED		      85
#define TMSG_OLD_PIV_FORMAT_SAVE_DOC_WITH_THOT	      86
#define TMSG_CREATING_BOX			      87
#define TMSG_NOT_ENOUGH_MEMORY			      88
#define TMSG_SEL_EL_TYPE		              89
#define TMSG_HOLOPHRAST_IMP			      90
#define TMSG_SEL_REFERRED_EL		              91
#define TMSG_TOO_MANY_DOCS			      92
#define TMSG_EMPTY_DOC_NOT_WRITTEN		      93
#define TMSG_INSERTING_IMP			      94
#define TMSG_NOTHING_TO_DEL			      95
#define TMSG_MANDATORY_ATTR			      96
#define TMSG_ALL_VIEWS_ALREADY_CREATED		      97
#define TMSG_EMPTY_DOC				      98
#define TMSG_CHANGING_DOC_IMP			      99
#define TMSG_LIB_TOO_MANY_VIEWS			     100
#define TMSG_NOTHING_TO_PASTE		             101
#define TMSG_OPENING_NEW_FRAME_IMP	             102
#define TMSG_DEBUG_ERROR		             103
#define TMSG_DEBUG_SAV_FILES                         104
#define TMSG_REALSIZE				     105
#define TMSG_RESCALE				     106
#define TMSG_FILLFRAME				     107
#define TMSG_XREPEAT				     108
#define TMSG_YREPEAT				     109
#define TMSG_PREMAT_EOF				     110
#define TMSG_NO_BOUNDING_BOX_IN_PS		     111
#define TMSG_HYPHEN_FILE_NOT_OPEN                    112
#define TMSG_HYPHEN_FILE_OPEN                        113
#define TMSG_HYPHEN_WORD_TOO_LONG                    114
#define TMSG_COLOR_INCORRECT			     115
#define TMSG_XPM_OPEN_ERR			     116
#define TMSG_XPM_FILE_INCORRECT                      117
#define TMSG_XPM_NO_MEM                              118
#define TMSG_XPM_COLOR_ERR                           119
#define TMSG_INCLUDE_FILE_IMP	                     120
#define TMSG_CREATE_FILE_IMP		             121
#define TMSG_EL_NOT_TRANSLATED	                     122
#define TMSG_TRA_FILE_INCORRECT		             123
#define TMSG_TOO_MANY_OUTPUT_FILES	             124
#define TMSG_CREATE_FRAME_FOR_VIEW		     125
#define TMSG_INVALID_SIBLING		             126
#define TMSG_INVALID_CHILD		             127
#define TMSG_ATTR_REQUIRED_FOR_EL		     128
#define TMSG_PAGE				     129
#define TMSG_LIB_UNKNOWN_TYPE			     130
#define TMSG_LANGUAGE			             131
#define TMSG_ATTR			             132
#define TMSG_SEARCH_REF		                     133
#define TMSG_STD_PRES	                             134
#define TMSG_APPLY			             135
#define TMSG_CHAR			             136
#define TMSG_LINE			             137
#define TMSG_GRAPHICS_PRES	                     138
#define TMSG_FORMAT			             139
#define TMSG_UNCHANGED			             140
#define TMSG_ALIGN			             141
#define TMSG_INDENT			             142
#define TMSG_LIB_PRINT			             143
#define TMSG_MANUAL_FEED		             144
#define TMSG_OPTIONS			             145
#define TMSG_A4				             146
#define TMSG_US		       		             147
#define TMSG_PAPER_SIZE		                     148
#define TMSG_DONE                                    149
#define TMSG_DOC_DIR	                             150
#define TMSG_DOCUMENT_NAME		             151
#define TMSG_FILE_EXIST			             152
#define TMSG_BUTTON_1                                153
#define TMSG_BUTTON_2                                154
#define TMSG_FONT_FAMILY	       	             155
#define TMSG_ROMAN			             156
#define TMSG_BOLD		          	     157
#define TMSG_ITALIC			             158
#define TMSG_OBLIQUE			             159
#define TMSG_NOT_BOLD				     160
#define TMSG_BOLDNESS				     161
#define TMSG_NORMAL			             162
#define TMSG_UNDERLINE			             163
#define TMSG_CROSS_OUT			             164
#define TMSG_BODY_SIZE_PTS	       	             165
#define TMSG_INDENT_PTS 		             166
#define TMSG_LINE_SPACING_PTS		             167
#define TMSG_LINE_SPACING	       	             168
#define TMSG_JUSTIFY		                     169
#define TMSG_LIB_YES			             170
#define TMSG_LIB_NO		                     171
#define TMSG_SAVE_DOC		                     172
#define TMSG_CLOSE_DON_T_SAVE		             173
#define TMSG_STYLE			             174
#define TMSG_COLORS			             175
#define TMSG_DEL			             176
#define TMSG_OUTPUT			             177
#define TMSG_PS_FILE		                     178
#define TMSG_PRINTER     		             179
#define TMSG_SEARCH_FOR		       	             180
#define TMSG_UPPERCASE_EQ_LOWERCASE    	             182
#define TMSG_REPLACE_BY		       	             183
#define TMSG_REPLACE			             184
#define TMSG_NO_REPLACE  		             185
#define TMSG_REPLACE_ON_REQU 	                     186
#define TMSG_AUTO_REPLACE  	                     187
#define TMSG_SEARCH_WHERE		             188
#define TMSG_BEFORE_SEL		                     189
#define TMSG_WITHIN_SEL		                     190
#define TMSG_AFTER_SEL		                     191
#define TMSG_IN_WHOLE_DOC  	                     192
#define TMSG_DO_NOT_REPLACE		             193
#define TMSG_STD_COLORS		                     194
#define TMSG_BEFORE_CLOSING		             195
#define TMSG_CLOSE_DOC		                     196
#define TMSG_NO_NAME			             197
#define TMSG_CREATE_DOC		                     198
#define TMSG_DOC_TYPE	       	                     199
#define TMSG_RENAME			             200
#define TMSG_MATH_SYMBOLS       	             201
#define TMSG_GRAPHICS			             202
#define TMSG_LATIN_ALPHABET		             203
#define TMSG_GREEK_ALPHABET		             204
#define TMSG_PRES		                     205
#define TMSG_FILES			             206
#define TMSG_OPEN_DOC		                     207
#define TMSG_IMPORT_DOC_TYPE		             208
#define TMSG_VIEWS	       		             209
#define TMSG_CHANGE_FILTER		             210
#define TMSG_VALUE_NOT_CHANGED		             211
#define TMSG_INCREASE			             212
#define TMSG_DECREASE			             213
#define TMSG_VISIB			             214
#define TMSG_CHANGE_ZOOM	       	             215
#define TMSG_LIB_ZOOM		       	             216
#define TMSG_SAVE_AS				     217
#define TMSG_SAVE				     218
#define TMSG_THOT_APP				     219
#define TMSG_DOC_FORMAT				     220
#define TMSG_COPY				     221
#define TMSG_TEXT				     222
#define TMSG_GRAPHIC				     223
#define TMSG_SYMBOL				     224
#define TMSG_PICTURE				     225
#define TMSG_EL_TYPE				     226
#define TMSG_AFTER				     227
#define TMSG_BEFORE				     228
#define TMSG_AROUND				     229
#define TMSG_INCLUDE				     230
#define TMSG_PASTE				     231
#define TMSG_TO_CREATE				     232
#define TMSG_INSERT				     233
#define TMSG_PAGE_BRK				     234
#define TMSG_READ_ONLY				     235
#define TMSG_SURROUND				     236
#define TMSG_CHANGE_TYPE			     237
#define TMSG_LANG_OF_EL			             238
#define TMSG_INHERITED_LANG			     239
#define TMSG_DO_NOT_CHANGE_DOC			     240
#define TMSG_NOT_FOUND				     241
#define TMSG_SEARCH_IN				     242
#define TMSG_SEARCH_EMPTY_EL			     243
#define TMSG_SEARCH_EMPTY_REF			     244
#define TMSG_SEARCH_REF_TO_EL			     245
#define TMSG_LINK				     246
#define TMSG_REF_IN_DOC			             247
#define TMSG_SEARCH				     248
#define TMSG_EL_RO				     249
#define TMSG_NOTHING_TO_REPLACE			     250
#define TMSG_OPEN				     251
#define TMSG_STD_CHAR			             252
#define TMSG_STD_GRAPHICS			     253
#define TMSG_STD_FORMAT				     254
#define TMSG_STD_GEOMETRY			     255
#define TMSG_TYPOGRAPHIC_POINTS			     256
#define TMSG_LINE_STYLE				     257
#define TMSG_LINE_WEIGHT			     258
#define TMSG_FILL_PATTERN			     259
#define TMSG_SPLIT				     260
#define TMSG_OBJECT_TYPE			     261
#define TMSG_GOTO_PAGE				     262
#define TMSG_ANY				     263
#define TMSG_ATTR_TO_SEARCH			     264
#define TMSG_TYPE_TO_SEARCH			     265
#define TMSG_NATURES				     266
#define TMSG_VALUE_OF_ATTR			     267
#define TMSG_UNKNOWN_ATTR			     268
#define TMSG_CREATE_EL_REF			     269
#define TMSG_SHOW_EL_REF			     270
#define TMSG_MODE_INSERT			     271
#define TMSG_CANCEL                                  272
#define TMSG_ERROR_PS_TRANSLATION                    273
#define TMSG_UNKNOWN_PRINTER                         274
#define TMSG_CANNOT_CREATE_PS			     275
#define TMSG_GLOBAL_LAYOUT			     276
#define TMSG_UNABLE_LINK_NEW_ELEM                    277
#define TMSG_CHAR_ENCODING			     278
#define TMSG_NO_LANGUAGE			     279
#define TMSG_OVERLINE				     280
#define TMSG_DOCUMENT_FORMAT			     281
#define TMSG_EVENTS				     282
#define TMSG_DEL_ATTR				     283
#define TMSG_PROFILE			             284
#define TMSG_CPBUTTON_1                              285
#define TMSG_CPBUTTON_2                              286
#define TMSG_LIB_MSG_MAX                             287

#endif
